/*
 * News Leech + Decode functions for PIMPPA
 *
 * by ~g / RRR S0R0R1TY Division
 *
 *
 * Uses: suck, uudeview
 *
 *
 */

#include <errno.h>
#include <time.h>
#include <ctype.h>
#include <dirent.h>
#include <getopt.h>
#include <unistd.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/vfs.h>

#include "pimppa.h"
#include "news.h"

char NNTPServer[BUFFSIZE];			// NNTP Server name
char GroupString[255];				// To match newsgroups

int Nazi=0;							// Only accept files w/ predefined pattern
int Verbose=0;
int WaitSecs=2;
int WaitAfter=10;

int TotalByteCount=0;
int GainByteCount=0;
int TotalFileCount=0;
int GainFileCount=0;

MYSQL src_db, dst_db;

int getncomp(char *string, int howmany, char *stderr);	
int getlastcomp(char *string);
int decode(char *filename, char *dstarea);
int process(char *path, char *dstarea);
int addnew(char *fullpath);
int dupecheck(char *filename, int area_id);
int dupecheck_single(char *escaped_fn, int area_id);
int dupecheck_regexp(char *escaped_fn, char *regexp);
bint getfreespace(char *path);

int p_dlnews(char *server, char *groups, int options, int waita, int waits)
{
	FILE *fp, *dp;
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;
	char combuf[BUFFSIZE];
	char olddir[PATH_MAX];
    char datafile[PATH_MAX];
	char grouppat[255];
	int spaceleft=1;
	struct stat st;
	time_t timetemp;

	if(!server || !server[0])
		return(-1);

	strcpy(NNTPServer, server);

	if(groups && groups[0])
		strcpy(GroupString, groups);
	else
		GroupString[0]=0;

	if(options & OPT_NAZI)
		Nazi=1;
	if(options & OPT_VERBOSE)
		Verbose=1;

	WaitAfter=waita;
	WaitSecs=waits;
	
	if(!p_connect(&src_db))
		return(-1);
	if(!p_connect(&dst_db))
	{
		mysql_close(&src_db);
		return(-1);
	}

	if((fp=fopen(LOCKFILE, "r")))
	{
		int lock_pid;
	
		fscanf(fp, "%d", &lock_pid);
		fclose(fp);
		if(kill(lock_pid, 0) == -1 && errno == ESRCH)
			unlink(LOCKFILE);
		else
		{
			fprintf(stderr,"Some automaton is already running, see %s\n",
					LOCKFILE);
			return(-1);
		}
	}
			
	if((fp=fopen(LOCKFILE, "w")))
	{
		fprintf(fp, "%d", getpid());
		fclose(fp);
	}
	else
	{
		fprintf(stderr, "Hmm, unable to open %s for writing\n", LOCKFILE);
		return(-1);
	}

	setlinebuf(stderr);

	umask(002);

	getcwd(olddir, PATH_MAX);
	if(stat(P_DATADIR, &st)!=0)
		mkdir(P_DATADIR,0770);

	chdir(P_DATADIR);

	sprintf(datafile, "suck%d_dl.tmp", getpid());

	if(GroupString[0])			// Special match orders for group name?
	{
		sprintf(grouppat, "AND g_name like '%s'", 
				GroupString);
	}

	p_query(&dst_db, "SELECT g_name, g_last, area_path, area_id 
				FROM p_groups, p_areas
				WHERE g_dest=area_id
				%s
				AND NOT (g_flags & %ld)",
				(grouppat[0] ? grouppat : ""),
				GROUP_DISABLED);
	sql_res=mysql_store_result(&dst_db);
	if(!sql_res)
	{
		printf("%s\n", mysql_error(&dst_db));
		printf("No sql_res!\n");
		return(-1);
	}

	while((sql_row=mysql_fetch_row(sql_res)))	// Read group info
	{
		char dirtmp[PATH_MAX];
		char groupname[255];
		int lastread,i;

		if(!spaceleft || !isalnum(sql_row[0][0]))	// Just a safety check
			continue;

		i=1;dirtmp[0]=0;
		while(getncomp(sql_row[2], i, dirtmp)) // Try to create the directories
		{
//			fprintf(stderr, "Creat: %s %d\n", dirtmp, i);
			mkdir(dirtmp, 0770);
			i++;
		}
	
		if(stat(sql_row[2], &st)!=0)
		{
			fprintf(stderr, "Unable to create %s\n", sql_row[2]);
			continue;
		}

		dp=fopen("sucknewsrc", "w");		// Create rc for Suck
		if(!dp)
		{
			fprintf(stderr,"Unable to create sucknewsrc\n");
			unlink(LOCKFILE);
			return(-1);
		}
		fprintf(dp, "%s %s\n", sql_row[0], sql_row[1]);		// Create groupline
		fclose(dp);

		timetemp=time(NULL);
		printf("Date: %s", ctime(&timetemp));
		printf("Group: %s\n", sql_row[0]);

		sprintf(combuf, "suck %s -q -c -dd %s -W %d %d "
						"-HF %s/suck.history "
						"-w %d %d >%s",
				NNTPServer, P_DATADIR, WaitSecs, WaitAfter,
				P_DATADIR,
				WaitSecs*2, WaitAfter*2, datafile);
//		fprintf(stderr, "%s\n", combuf);
		system(combuf);									// Fetch messages

		if(stat(datafile, &st)==0 &&
			(bint)st.st_size>getfreespace(P_DATADIR))		// Check hd space
		{
			fprintf(stderr, "Eek, file larger than free space! Stopping.\n");
			spaceleft=0;
		}
	
		if(spaceleft)
			if(!decode(datafile, sql_row[3]))	// Decode the message file	
			{
				fprintf(stderr, "Critical error with decode to %s\n", sql_row[2]);
				unlink(LOCKFILE);
				return(-1);
			}

		dp=fopen("sucknewsrc", "r");			// Get the modified rc line
		if(!dp)
		{
			fprintf(stderr, "Unable to open 'sucknewsrc' for reading...\n");
			unlink(LOCKFILE);
			return(-1);
		}
		
		fscanf(dp, "%s %d", groupname, &lastread);
		fclose(dp);

		p_query(&dst_db, "UPDATE p_groups SET g_last=%d
						WHERE g_name='%s'",
						lastread, groupname);

		printf("\n");
	}

	mysql_free_result(sql_res);

	if(spaceleft)
		unlink(datafile);

	unlink("sucknewsrc");
	unlink("sucknewsrc.old");
	
	chdir(olddir);
		
	timetemp=time(NULL);
	printf("Finished: %s\n", ctime(&timetemp));
	printf("Total Files: %d Bytes: %d\n",
			TotalFileCount, TotalByteCount);
	printf("Gained Files: %d Bytes: %d\n\n",
			GainFileCount, GainByteCount);

	unlink(LOCKFILE);
	
	mysql_close(&src_db);
	mysql_close(&dst_db);

	return(0);
}

/*
 * Returns the n:th component of a string in style /joo/moo/muu
 *
 * NULL if none
 *
 */
int getncomp(char *string, int howmany, char *stderr)
{
	if(!string || !stderr)
		return(0);

	if(!string[0])
	{
		stderr[0]=0;
		return(0);
	}

//	printf("got: %d\n", howmany);

	while(*string!=0 && howmany>0)
	{
		if(string[0]=='/')
		{
			howmany--;
		}
		*stderr=*string;
		stderr++; string++;
	}

	*stderr=0;

	if(howmany==0)
		return(1);
	else
		return(0);
}

	
/*
 * Returns the last component after a dot in a string with the format
 *
 * blaa.bloo.blii.bluup  == bluup 
 *
 */
int getlastcomp(char *string)
{
	int i;

	i=strlen(string);
	while(i>0 && string[i]!='.')
		i--;

	if(i>0)
		return(i+1);
	else
		return(0);
}

/*
 * Decodes the contents of file "filename" to dstdir
 *
 */
int decode(char *filename, char *dstarea)
{
	char buffer[BUFFSIZE];
	char tmp_path[PATH_MAX];
	
//	getcwd(buffer, BUFFSIZE);
//	printf("cur: %s", buffer);
	sprintf(tmp_path, "pleech_tmp%d", getpid());	// Make temporary dir
	mkdir(tmp_path,0770);
	
	printf("Decoding...\n");

	sprintf(buffer, "uudeview -m -n -v -i -o -p %s %s >/dev/null", 
			tmp_path, filename);
	system(buffer);						// Decode to temp dir
//	fprintf(stderr, "%s\n", buffer);

	printf("Processing...\n");
	process(tmp_path, dstarea);		// Remove duplicate files from tmp
										// Adds the files too
										// Performs assigns!

	rmdir(tmp_path);
	
//	fprintf(stderr, "Result: %d\n", system(buffer));

	return(1);
}

/*
 * Checks directory "path" and deletes all files from it which
 * are found to be duplicates or otherwise unsuitable.
 *
 */
int process(char *path, char *dstarea)
{
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;
	DIR *dirp;
	struct dirent *dirdata;
	int total_files=0,total_bytes=0;
	int assigned_files=0,assigned_bytes=0;
	int deleted_files=0,deleted_bytes=0;
	int default_area=atoi(dstarea);

	dirp=opendir(path);
	if(!dirp)
		return(0);
	
	while((dirdata=readdir(dirp)))
	{
		char fullpath[PATH_MAX];
		char transname[PATH_MAX];				// Future xformed filename
		char *transptr;
		int new_file;
		char *filename=dirdata->d_name;
		struct stat st;
		char pattern[P_LEN_FILE_NAME];
		char escaped_fn[2*P_LEN_FILE_NAME+1];
		int destarea_id;

		new_file=1;destarea_id=default_area;
		sprintf(fullpath, "%s/%s", path, filename);

		stat(fullpath, &st);
		if(!(S_ISREG(st.st_mode) || S_ISLNK(st.st_mode))
			|| S_ISDIR(st.st_mode))
			continue;
		
		if(Verbose)
			printf("%s\n", fullpath);
		
		total_files++;
		total_bytes+=st.st_size;

		if(NEEDNUMBER)						// Must it have a number?
		{	
			if(!p_checkfornumber(filename))	// No number!
			{
				if(Verbose)
					printf("	!! Discarded, no number in filename\n");
					
				new_file=0;
			}
		}
		if(new_file && NEEDLETTER)			// How about a letter?
		{
			if(!p_checkforletter(filename))	// No letter!
			{
				if(Verbose)
					printf("	!! Discarded, no letter in filename\n");
			
				new_file=0;
			}
		}
		if(new_file && NOSPACE)
		{
			if(p_checkforspace(filename)) // It has a space!
			{
				if(Verbose)
					printf("	!! Discarded, space in filename\n");
					
				new_file=0;
			}
		}

		if(!new_file)
		{
			unlink(fullpath);
			deleted_files++;
			deleted_bytes+=st.st_size;
			continue;
		}
				
		if(TO_LOWERCASE)				// Convert filename
		{
			char newpath[PATH_MAX];

			p_strtolc(filename);
					
			sprintf(newpath, "%s/%s", path, filename);
			rename(fullpath, newpath);
			
			strcpy(fullpath, newpath);
		}

/************ Dupecheck for current filename *************************/
		
		if(dupecheck(filename, destarea_id))	// Exists, delete it
		{
				unlink(fullpath);
				deleted_files++;
				deleted_bytes+=st.st_size;
			
				if(Verbose)
					printf("	!! Exists, deleted\n");
				
				continue;
		}

/************ Dupecheck for future transformed filename *********/

		strcpy(transname, filename);
		transptr=strrchr(transname, '.')+1;		// Next char from '.'
		if(transptr)
		{
			char ext[PATH_MAX];
			char escaped_transn[2*P_LEN_FILE_NAME+1];

			ext[0]=0;
		
			mysql_escape_string(escaped_transn, transptr, strlen(transptr));

			p_query(&src_db, "SELECT type_transto
							FROM p_types
							WHERE type_ext='%s'
							AND type_transcmd<>''
							AND type_transto<>''",
							escaped_transn);
			if(mysql_error(&src_db)[0])
			{
				fprintf(stderr, "Err: %s\n", mysql_error(&src_db));
				break;
			}
			sql_res=mysql_store_result(&src_db);
			if(sql_res)
			{
				if((sql_row=mysql_fetch_row(sql_res)))
					strcpy(ext, sql_row[0]);
				
				mysql_free_result(sql_res);
			}

			if(ext[0])
			{
				strcpy(transptr, ext);				// Attach new extension
	
				if(strcmp(transname, filename)!=0)  // Name changed?
				{
					if(Verbose)
						printf("	=> %s\n", transname);

					if(dupecheck(transname, destarea_id)) // Exists
					{
							unlink(fullpath);
							deleted_files++;
							deleted_bytes+=st.st_size;
				
							if(Verbose)
								printf("	!! Trans exists, deleted\n");
				
							continue;
					}
				}
			}
		}
	
/**** Create assign pattern && locate new destination area id *************/
		
		if(p_makepattern(pattern, filename)>=P_MIN_ASS_NAMELENGTH)
		{
			char escaped_pat[2*P_LEN_FILE_NAME+1];

			mysql_escape_string(escaped_pat, pattern, strlen(pattern));

			// Locate the destination area id
			p_query(&src_db, "SELECT a_dest FROM p_assign
							WHERE a_pattern='%s'", escaped_pat);
			sql_res=mysql_store_result(&src_db);
			if(sql_res)
			{
				if((sql_row=mysql_fetch_row(sql_res)))
					destarea_id=atoi(sql_row[0]);
				mysql_free_result(sql_res);
			}

			// Check the typical target areas. If destarea_id is not
			// among them, reset it to default_area
			if(destarea_id>0)
			{
				p_query(&src_db, "SELECT 
								  (%d REGEXP area_targets)
								  FROM p_areas
			   			          WHERE area_id=%d",
							     destarea_id, default_area);
				sql_res=mysql_store_result(&src_db);
				if(sql_res)	
				{
					if(!(sql_row=mysql_fetch_row(sql_res))) 
					{
						printf("	!! Resetting target area to default\n");
						destarea_id=default_area;
					}
					mysql_free_result(sql_res);
				}
			}

			if(Verbose && destarea_id==-1)
				printf("	!! Assign patterns ordered autokill\n");
		}

		if(destarea_id==default_area && Nazi)	// Unknown file, delete!
		{ 
			if(Verbose)
				printf("	!! NaziSays: Delete!\n");

			destarea_id=-1;
		}

/****** Dupecheck from the new destination area *****************/
	
/* not needed in the new 'reset assign pattern to def' scene?

		if(destarea_id>=0 && destarea_id!=default_area)
		{
			if(dupecheck(filename, destarea_id))	// Exists, delete it
			{
				if(Verbose)
					printf("	!! Exists on assigned area, deleted\n");
				
				destarea_id=-1;
			}
		}
*/

		if(destarea_id<0)					// Marked for deletion?
		{	
			unlink(fullpath);
			deleted_files++;
			deleted_bytes+=st.st_size;
			continue;
		}

/******* Locate destination area path and move file **************/

		p_query(&src_db, "SELECT area_path FROM p_areas
						WHERE area_id=%d",
						destarea_id);
		sql_res=mysql_store_result(&src_db);
		if(sql_res)
		{
			if((sql_row=mysql_fetch_row(sql_res)))	// Ok, assign!
			{
				char newpath[PATH_MAX];

				sprintf(newpath, "%s%s%s", 
						sql_row[0], 
						(p_checkp(sql_row[0]) ? "" : "/"),
						filename);
				
				if(!p_mv(fullpath, newpath))
				{
					fprintf(stderr, "p_mv() error from %s to %s\n",
							fullpath, newpath);
				}
						
				strcpy(fullpath, newpath);
						
				assigned_files++;
				assigned_bytes+=st.st_size;
				
				if(Verbose)
					printf("	=> %s\n", sql_row[0]);

			}
			mysql_free_result(sql_res);
		}

		mysql_escape_string(escaped_fn, filename, strlen(filename));
		
		p_query(&src_db, "REPLACE INTO p_files (file_name, file_size,
						file_area,file_date,file_backup)
						VALUES ('%s',%ld,%d,FROM_UNIXTIME(%ld),0)",
						escaped_fn, st.st_size, destarea_id, 
						(long) time(NULL));
	
		if(Verbose)
			printf("	== OK\n");
	}

	closedir(dirp);

	TotalByteCount+=total_bytes;
	GainByteCount+=(total_bytes-deleted_bytes);
	TotalFileCount+=total_files;
	GainFileCount+=(total_files-deleted_files);

	printf("Ok, %d/%d files and %d/%d bytes assigned to fileareas.\n"
			"%d files and %d bytes were deleted.\n",
			assigned_files,total_files, assigned_bytes,total_bytes,
			deleted_files, deleted_bytes);

	return(total_files-deleted_files);
}

/*
 * Returns free HD space
 *
 */
bint getfreespace(char *path)
{
	struct statfs freest;

	if(!statfs(path,&freest))
		return((bint)freest.f_bsize*(bint)freest.f_bavail);

	return(0);
}

/*
 * Returns 1 if file exists on "area_id", or on any area that
 * is defined in p_areas -table as that areas immediate target areas.
 *
 * 0 is returned if file is not found.
 *
 */
int dupecheck(char *filename, int area_id)
{
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;
	char escaped_fn[PATH_MAX];
		
	mysql_escape_string(escaped_fn, filename, strlen(filename));

	if(area_id==-1)						// Check from all areas
	{
//		printf("	DEBUG: Dupechecking %s from all...\n", filename);

		p_query(&src_db, "SELECT 1 FROM p_files 
						WHERE file_name='%s' AND file_integ!=%d", 
						escaped_fn, INTEG_FAILED);
		sql_res=mysql_store_result(&src_db);
		if(sql_res)
		{
			if(mysql_num_rows(sql_res)>0)		// Exists
			{
				mysql_free_result(sql_res);
				return(1);
			}

			mysql_free_result(sql_res);
		}
		return(0);
	}

/************ Specific area and its targets *****************/

	if(dupecheck_single(escaped_fn, area_id))
		return(1);
	
	p_query(&src_db, "SELECT area_targets FROM p_areas
		              WHERE area_id=%d",
				      area_id);
	sql_res=mysql_store_result(&src_db);
	if(sql_res)	
	{
		if(!(sql_row=mysql_fetch_row(sql_res)))
		{
			mysql_free_result(sql_res);
			return(0);
		}	

		if(dupecheck_regexp(escaped_fn, sql_row[0]))
		{
			mysql_free_result(sql_res);
			return(1);
		}
		mysql_free_result(sql_res);
	}

	return(0);
}

/*
 * Dupechecks from a single area, no target areas noted
 *
 */
int dupecheck_single(char *escaped_fn, int area_id)
{
	MYSQL_RES *sql_res;

//	printf("	DEBUG: Dupechecking %s from %d\n", escaped_fn, area_id);

	p_query(&src_db, "SELECT 1 FROM p_files
		              WHERE file_name='%s' AND file_integ!=%d
					  AND file_area=%d",
				      escaped_fn, INTEG_FAILED, area_id);
	sql_res=mysql_store_result(&src_db);
	if(sql_res)	
	{
		if(mysql_num_rows(sql_res)>0)		// Exists
		{
			mysql_free_result(sql_res);
			return(1);
		}
		mysql_free_result(sql_res);
	}

	return(0);
}

/*
 * Dupechecks from regexp areas
 *
 */
int dupecheck_regexp(char *escaped_fn, char *regexp)
{
	MYSQL_RES *sql_res;

//	printf("	DEBUG: RegExpDChecking %s from %s\n", escaped_fn, regexp);

	p_query(&src_db, "SELECT 1 FROM p_files
		              WHERE file_name='%s' AND file_integ!=%d
					  AND file_area RLIKE '%s'",
				      escaped_fn, INTEG_FAILED, regexp);
	sql_res=mysql_store_result(&src_db);
	if(sql_res)	
	{
		if(mysql_num_rows(sql_res)>0)		// Exists
		{
			mysql_free_result(sql_res);
			return(1);
		}
		mysql_free_result(sql_res);
	}

	return(0);
}

